Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.pattern
Class NodeTest

    java.lang.Object
      net.sf.saxon.pattern.NodeTest

All Implemented Interfaces:
  ItemType, java.io.Serializable

Direct Known Subclasses:
  AnyChildNodePattern, AnyNodeTest, CombinedNodeTest, ContentTypeTest, DocumentNodeTest, LocalNameTest, NamespaceTest, NameTest, NodeKindTest, NoNodeTest, SubstitutionGroupTest

public abstract class NodeTest
extends java.lang.Object
implements ItemType, java.io.Serializable

A NodeTest is a simple kind of pattern that enables a context-free test of whether a node has a particular name. There are several kinds of node test: a full name test, a prefix test, and an "any node of a given type" test, an "any node of any type" test, a "no nodes" test (used, e.g. for "@comment()").

As well as being used to support XSLT pattern matching, NodeTests act as predicates in axis steps, and also act as item types for type matching.

See Also:
  Serialized Form

Constructor Summary
`NodeTest()`

Method Summary
`AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
`SchemaType` | `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
`abstract double` | `getDefaultPriority()` Determine the default priority of this node test when used on its own as a Pattern
`int` | `getFingerprint()` Get the name of the nodes matched by this nodetest, if it matches a specific name.
`abstract int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
`ItemType` | `getPrimitiveItemType()` Get the primitive item type corresponding to this item type.
`int` | `getPrimitiveType()` Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
`java.util.Set` | `getRequiredNodeNames()` Get the set of node names allowed by this NodeTest.
`ItemType` | `getSuperType()` Get the type from which this item type is derived by restriction.
`abstract boolean` | `matches(int nodeKind, int fingerprint, int annotation)` Test whether this node test is satisfied by a given node.
`abstract boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
`boolean` | `matchesItem(Item item)` Test whether a given item conforms to this type.
`java.lang.String` | `toString(NamePool pool)` Display the type descriptor for diagnostics

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NodeTest

    public NodeTest()

Method Detail

### matchesItem

    public boolean matchesItem(Item item)

  Test whether a given item conforms to this type. This implements a method of the ItemType interface.

  Specified by:
    `matchesItem` in interface `ItemType`
  Parameters:
    `item` - The item to be tested
  Returns:
    true if the item is an instance of this type; false otherwise

### getSuperType

    public ItemType getSuperType()

  Description copied from interface: `ItemType`
  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xdt:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  Specified by:
    `getSuperType` in interface `ItemType`
  Returns:
    the supertype, or null if this type is item()

### getDefaultPriority

    public abstract double getDefaultPriority()

  Determine the default priority of this node test when used on its own as a Pattern

### getPrimitiveItemType

    public ItemType getPrimitiveItemType()

  Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

  Specified by:
    `getPrimitiveItemType` in interface `ItemType`

### getPrimitiveType

    public int getPrimitiveType()

  Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.

  Specified by:
    `getPrimitiveType` in interface `ItemType`
  Returns:
    the node kind matched by this node test

### getFingerprint

    public int getFingerprint()

  Get the name of the nodes matched by this nodetest, if it matches a specific name. Return -1 if the node test matches nodes of more than one name

### getAtomizedItemType

    public AtomicType getAtomizedItemType()

  Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)

  Specified by:
    `getAtomizedItemType` in interface `ItemType`

### matches

    public abstract boolean matches(int nodeKind,
                                    int fingerprint,
                                    int annotation)

  Test whether this node test is satisfied by a given node. This method is provided so that (when navigating a TinyTree in particular) a node can be rejected without actually instantiating a NodeInfo object.

  Parameters:
    `nodeKind` - The kind of node to be matched
    `fingerprint` - identifies the expanded name of the node to be matched. The value should be -1 for a node with no name.
    `annotation` - The actual content type of the node

### matches

    public abstract boolean matches(NodeInfo node)

  Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.

  Parameters:
    `node` - the node to be matched

### getNodeKindMask

    public abstract int getNodeKindMask()

  Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<

### getContentType

    public SchemaType getContentType()

  Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.

### getRequiredNodeNames

    public java.util.Set getRequiredNodeNames()

  Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. A null value indicates that all names are permitted (i.e. that there are no constraints on the node name. The default implementation returns null.

### toString

    public java.lang.String toString(NamePool pool)

  Display the type descriptor for diagnostics

  Specified by:
    `toString` in interface `ItemType`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD